<html>
<head>
<META http-equiv="Content-Type" content="text/html; charset=UTF-8">
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<link rel="stylesheet" href="../../../../../..//default_style.css" type="text/css">
<link rel="stylesheet" href="../../../../../..//webtools/wtp.css" type="text/css">
<title>WTP 1.5 Milestone 5</title>
</head>
<body>
<table width="100%" cellspacing="5" cellpadding="2" border="0">
<tbody>
<tr>
<td width="60%" align="left"><font class="indextop">XML Test Plan</font>
<br>
<font class="indexsub">WTP 1.5 Milestone 5</font></td><td width="40%"><img width="207" hspace="50" height="129" align="middle" src="../../../../../..//images/wtplogosmall.jpg"></td>
</tr>
</tbody>
</table>
<table width="100%" cellspacing="5" cellpadding="2" border="0">
<col width="16">
<col width="*">
<tbody>
<tr>
<td valign="top" bgcolor="#0080c0" align="left" colspan="2"><b><font face="Arial,Helvetica" color="#ffffff">Status of this Plan</font></b></td>
</tr>
<tr>
<td valign="top" align="right">&nbsp;</td><td valign="top">
<p>Proposed Plan (2.24.05)</p>
</td>
</tr>
<tr>
<td valign="top" bgcolor="#0080c0" align="left" colspan="2"><b><font face="Arial,Helvetica" color="#ffffff">Overall goals</font></b></td>
</tr>
<tr>
<td valign="top" align="right"><img width="16" height="16" border="0" src="../../../../../..//images/Adarrow.gif"></td><td>
			<b>New for M5</b>
		</td>
</tr>
<tr>
<td valign="top" align="right">&nbsp;</td><td valign="top">
<p>
			Not much has been added in terms of new functionality for
			M5. Most of the work done was in the areas of refactoring,
			cleaning up dead code, and cleaning up APIs. Also more unit
			tests were added which are run regularly with the build.
		</p>
</td>
</tr>
<tr>
<td valign="top" align="right"><img width="16" height="16" border="0" src="../../../../../..//images/Adarrow.gif"></td><td>
			<b>Co-developer Testing</b>
		</td>
</tr>
<tr>
<td valign="top" align="right">&nbsp;</td><td valign="top">
<p>
			We will inspect "runtime" version of build to be
			sure extra source is not included, and more important, we'll
			inspect and test importing SDK version to be sure all
			relevant "open source" is included in that SDK
			build and that it correctly imports into a development
			environment.
		</p>
</td>
</tr>
<tr>
<td valign="top" align="right"><img width="16" height="16" border="0" src="../../../../../..//images/Adarrow.gif"></td><td>
			<b>API Testing</b>
		</td>
</tr>
<tr>
<td valign="top" align="right">&nbsp;</td><td valign="top">
<p>
			Here in M5 we don't consider we have any official API yet
			(since not spec'd as such) but will reserve this space for
			future plans to details were API Unit tests are, their
			coverage, etc.
		</p>
</td>
</tr>
<tr>
<td valign="top" align="right">&nbsp;</td><td valign="top">
<p>
			We do have several hundred unit tests which we expect to be
			running and passing for M5, which test various aspects of
			parsing, model creation, and correct charset handling, among
			other things.
		</p>
</td>
</tr>
<tr>
<td valign="top" align="right"><img width="16" height="16" border="0" src="../../../../../..//images/Adarrow.gif"></td><td>
			<b>End User Testing</b>
		</td>
</tr>
<tr>
<td valign="top" align="right">&nbsp;</td><td valign="top">
<p>
			The nature of the end-user testing is intentionally planned
			to be "ad hoc" instead of specifying step by step "how to"
			directions and specific "expected results" sections often
			seen in test cases. This is done because its felt leads to
			greater number of "paths" being tested, and allows end-users
			more motivation for logging "bugs" if things didn't work as
			<i>they</i>
			expected, even if it is working as designed.
		</p>
</td>
</tr>
<tr>
<td valign="top" align="right">&nbsp;</td><td valign="top">
<p>
			As we progress through milestones, we'll add more and more
			detail for special cases, special files, special projects,
			etc.When we do have special or sample test files and
			projects, we will keep those stored in CVS, as projects
			under a
			<i>testdata</i>
			directory under the
			<i>development</i>
			directory of relevant component so that testers (from
			immediate team, or community) can easily check out into the
			environment being tested.
		</p>
</td>
</tr>
<tr>
<td valign="top" align="right"><img width="16" height="16" border="0" src="../../../../../..//images/Adarrow.gif"></td><td>
			<b>Platform Testing</b>
		</td>
</tr>
<tr>
<td valign="top" align="right">&nbsp;</td><td valign="top">
<p>
			While we do not have any platform specific code, or
			function, we will have some team members do end-user tests
			on Linux, some on Windows. We will also confirm unit tests
			pass on both platforms.
		</p>
</td>
</tr>
<tr>
<td valign="top" align="right"><img width="16" height="16" border="0" src="../../../../../..//images/Adarrow.gif"></td><td>
			<b>Performance Testing</b>
		</td>
</tr>
<tr>
<td valign="top" align="right">&nbsp;</td><td valign="top">
<p>
			We have added (some) automated performance tests along the
			lines of the Eclipse base performance unit tests in future
			milestones. These are currently in the
			<b>org.eclipse.wst.*.ui.tests.performance</b>
			and
			<b>org.eclipse.jst.jsp.ui.tests.performance</b>
			plugins.
			<br>
			
<br>
			We will continue to add more test cases in upcoming
			milestones.
		</p>
</td>
</tr>
<tr>
<td valign="top" bgcolor="#0080c0" align="left" colspan="2"><b><font face="Arial,Helvetica" color="#ffffff">XML Tests</font></b></td>
</tr>
<tr>
<td valign="top" align="right">&nbsp;</td><td valign="top">
<ul>
			
<li>
				check Source Editing features from feature
				<a href="../../sse/M5/milestone_test_plan.html#matrix">feature matrix</a>
				
<br>
				check samples of range of types of web resources
				(web.xml, tld files, schema source, etc)
				<br>
				especially any we (WTP) generate
			</li>
			
<li>
				test Design page, Source page, Outline view, Properties
				view synchronization
			</li>
			
<li>
				check content assist and source validation using content
				model from the following source:
				<ul>
					
<li>
						inferred content model (XML with no DOCTYPE or
						schema specified)
					</li>
					
<li>DTD from XML catalog</li>
					
<li>DTD from URI</li>
					
<li>schema from XML catalog</li>
					
<li>schema from URI</li>
					
<li>
						basic schema (with lots of complex types, and
						lots of 'includes')
					</li>
					
<li>advanced schema (with lots of namespaces)</li>
				
</ul>
			
</li>
			
<li>
				A quick sanity check that preferences have effect, and
				do no harm. Only quick check, since many changes planned
				in this are for future milestones.
			</li>
		
</ul>
</td>
</tr>
<tr>
<td valign="top" align="right">&nbsp;</td><td valign="top">
<p>

			
<ul>
				
<li>
					as you type validation:
					<ul>
						
<li>
							job based, make sure squiggles show up when
							they should and are removed when problems
							are fixed
						</li>
						
<li>
							test various partition types in the document
						</li>
						
<li>
							new Xerces-style validators (for
							as-you-type)
						</li>
						
<li>XSD validator (for as-you-type)</li>
					
</ul>
				
</li>

				
<li>
					hyperlink open on:
					<ul>
						
<li>schema location, dtd location</li>
					
</ul>
				
</li>

				
<li>
					preferences:
					<ul>
						
<li>
							how we use the preferences in the "All Text
							Editors" preference page now.
						</li>
						
<li>make sure preferenes work</li>
						
<li>after shutdown and restart</li>
					
</ul>
				
</li>

				
<li>
					run performance unit tests:
					<ul>
						
<li>
							record results for comparison with future
							milestones
						</li>
					
</ul>
				
</li>

				
<li>
					profiling:
					<ul>
						
<li>
							test basic editor functions and look for
							problem areas (large memory consumption,
							intense cpu usage)
						</li>
					
</ul>
				
</li>

			
</ul>
		
</p>
</td>
</tr>
<tr>
<td valign="top" align="right">&nbsp;</td><td valign="top"><b>General Scenario</b></td>
</tr>
<tr>
<td valign="top" align="right">&nbsp;</td><td valign="top">
<ul>
			
<li>
				Validate an invalid document and ensure problems are
				shown as annotations in the editor's source ruler and
				margin
			</li>

			
<li>
				Check that error messages are listed in the problems
				view
			</li>
			
<li>Check that navigation works for error markers</li>
			
<li>Check that line numbers match error markers</li>
			
<li>
				Correct errors and revalidate and ensure all markers and
				messages are removed
			</li>
			
<li>
				Ensure popup message dialog appear with the correct
				validation message
			</li>
		
</ul>
</td>
</tr>
<tr>
<td valign="top" align="right">&nbsp;</td><td valign="top"><b>XML Catalog</b></td>
</tr>
<tr>
<td valign="top" align="right">&nbsp;</td><td valign="top">
<ul>
			
<li>Test that validation works with the XML Catalog</li>
		
</ul>
</td>
</tr>
<tr>
<td valign="top" align="right">&nbsp;</td><td valign="top"><b>Referenced Files</b></td>
</tr>
<tr>
<td valign="top" align="right">&nbsp;</td><td valign="top">
<ul>
			
<li>Test errors in referenced files</li>
			
<li>
				good xml, bad xsd. ie. XSD errors should not show in XML
				resource. There should be however one message to
				indicate that there are errors in the referenced file
			</li>
			
<li>Test similarly also for good xml, bad dtd</li>
		
</ul>
</td>
</tr>
<tr>
<td valign="top" align="right">&nbsp;</td><td valign="top"><b>Validation Preferences</b></td>
</tr>
<tr>
<td valign="top" align="right">&nbsp;</td><td valign="top">
<ul>
			
<li>Test validate on file save</li>
			
<li>Turn it on and off</li>
			
<li>Test global vs project settings</li>
			
<li>Test maximum number of messages</li>
		
</ul>
</td>
</tr>
<tr>
<td valign="top" align="right">&nbsp;</td><td valign="top"><b>XML Examples</b></td>
</tr>
<tr>
<td valign="top" align="right">&nbsp;</td><td valign="top">
<ul>
			
<li>
				Create the Editing and validating XML files Examples
			</li>
			
<li>
				Verify that the sample files are created in the
				designated folder
			</li>
		
</ul>
</td>
</tr>
<tr>
<td valign="top" align="right">&nbsp;</td><td valign="top"><b>XML Tutorials</b></td>
</tr>
<tr>
<td valign="top" align="right">&nbsp;</td><td valign="top">
<ul>
			
<li>Excercise XML Catalog tutorial</li>
			
<li>Excercise XML Validation tutorial</li>
			
<li>Excersice Creating XML Documents tutorial</li>
		
</ul>
</td>
</tr>
<tr>
<td valign="top" align="right">&nbsp;</td><td valign="top">
<p>
			Problem icons (batch validation) should gray out in the
			editor when fixed.
		</p>
</td>
</tr>
<tr>
<td valign="top" align="right">&nbsp;</td><td valign="top">
<p>Tab Preferences</p>
</td>
</tr>
<tr>
<td valign="top" align="right">&nbsp;</td><td valign="top">
<ul>
			
<li>
				Web and XML-&gt;Content Type Files -&gt; Content Type Source
				-&gt; Indent using tabs / Indent using spaces -&gt;
				Indentation size
			</li>

			
<li>Verify the correct tab character is used</li>
			
<li>Verify the correct number of tab characters is used</li>
			
<li>
				Verify Source-&gt;Shift Left/Shift Right and the
				Shift-Tab/Tab key follow the preferences
			</li>
			
<li>With nothing selected</li>
			
<li>With multiple lines selected</li>
			
<li>Verify Format follow the preferences</li>
			
<li>
				Verify when using tab characters, the displayed tab
				width preference is followed (General-&gt;Editors-&gt;Text
				Editors -&gt; Displayed tab width)
			</li>
		
</ul>
</td>
</tr>
<tr>
<td valign="top" bgcolor="#0080c0" align="left" colspan="2"><b><font face="Arial,Helvetica" color="#ffffff">New for M5</font></b></td>
</tr>
<tr>
<td valign="top" align="right">&nbsp;</td><td valign="top">
<p>New File Wizard:</p>
</td>
</tr>
<tr>
<td valign="top" align="right">&nbsp;</td><td valign="top">
<ul>
			
<li>make sure the template creates a valid file</li>
			
<li>
				Verify not entering an extension will generate a new
				file with the default file extension you specified in
				the preference.
			</li>
			
<li>
				Verify entering a file name that already exists without
				the extension will still give you an error saying the
				file already exists (for example, if index.jsp already
				exists, typing "index" will tell you that it already
				exists)
			</li>
			
<li>
				Verify entering a file name with valid/invalid extension
				still works
			</li>
		
</ul>
</td>
</tr>
<tr>
<td valign="top" align="right">&nbsp;</td><td valign="top">
<p>File Preference Page:</p>
</td>
</tr>
<tr>
<td valign="top" align="right">&nbsp;</td><td valign="top">
<ul>
			
<li>
				A new preference was added, "Add this suffix (if not
				specified)"
			</li>
			
<li>
				Verify for that you can only enter extensions that are
				currently associated with the content type (via Content
				Type preference page)
			</li>
		
</ul>
</td>
</tr>
<tr>
<td valign="top" align="right">&nbsp;</td><td valign="top">
<p>Content Settings
		<br>
		General Content Settings
		</p>
</td>
</tr>
<tr>
<td valign="top" align="right">&nbsp;</td><td valign="top">
<ul>
			
<li>
				Verify project properties are inherited when file
				properties are not set
			</li>
			
<li>
				Verify setting properties actually saves the properties
				settings when you reopen properties dialog and when you
				restart workbench
			</li>
			
<li>
				Verify properties still valid/saved when you move the
				associated file
			</li>
			
<li>
				Verify nothing funny happens with build or if you have a
				readonly project or something that nothing goes wrong
				(since properties are stored inside project)
			</li>
		
</ul>
</td>
</tr>
<tr>
<td valign="top" align="right">&nbsp;</td><td valign="top">
<p>JSP Fragment</p>
</td>
</tr>
<tr>
<td valign="top" align="right">&nbsp;</td><td valign="top">
<ul>
			
<li>
				Verify JSP Fragment shows up in Properties dialog for
				jsp fragment files and web projects (and only then)
			</li>
			
<li>
				Verify Language/Content Type/Validation properties are
				used when not specified in JSP Fragments
			</li>
		
</ul>
</td>
</tr>
<tr>
<td valign="top" align="right">&nbsp;</td><td valign="top">
<ul>
			
<li>
				Verify Web Content Settings shows up in Properties
				dialog for html, jsp, css files and web projects (and
				only then)
			</li>
			
<li>
				For CSS files, there should only be a CSS Profile
				option. Verify it is used For HTML/JSP files there
				should also be a Document type option.
			</li>
			
<li>
				Verify it is used (for example, specify frameset doctype
				and verify content assist proposes frameset tag)
			</li>
		
</ul>
</td>
</tr>
<tr>
<td valign="top" bgcolor="#0080c0" align="left" colspan="2"><b><font face="Arial,Helvetica" color="#ffffff">
			<b>Regression Tests</b>
		</font></b></td>
</tr>
<tr>
<td valign="top" align="right">&nbsp;</td><td valign="top">
<p>
			
<a href="../../../../1.0/wst/sse/M8/viewerconfig-test.html">Structured Text Viewer Configuration tests</a>
			
<br>
<a href="../../../../1.0/wst/sse/M8/action-test.html">Structured Text Editor Action tests</a>
			
<br>
<a href="../../../../../wst/components/sse/M4/formatting-test.html">Formatting tests</a>
			
<br>
		
</p>
</td>
</tr>
<tr>
<td valign="top" bgcolor="#0080c0" align="left" colspan="2"><b><font face="Arial,Helvetica" color="#ffffff">Source Editing Test Plans</font></b></td>
</tr>
<tr>
<td valign="top" align="right">&nbsp;</td><td valign="top">
<p>
			
<a href="../../sse/M5/milestone_test_plan.html">org.eclipse.wst.sse</a>
			
<br>
<a href="../../xml/M5/milestone_test_plan.html">org.eclipse.wst.xml</a>
			
<br>
<a href="../../html/M5/milestone_test_plan.html">org.eclipse.wst.html</a>
			
<br>
<a href="../../css/M5/milestone_test_plan.html">org.eclipse.wst.css</a>
			
<br>
<a href="../../dtd/M5/milestone_test_plan.html">org.eclipse.wst.dtd</a>
			
<br>
<a href="../../javascript/M5/milestone_test_plan.html">org.eclipse.wst.javascript</a>
			
			
<br>
<a href="../../../jst/jsp/M5/milestone_test_plan.html">org.eclipse.jst.jsp</a>	
		
</p>
</td>
</tr>
</tbody>
</table>
</body>
</html>
